import { readable, writable } from 'svelte/store';

type IntroIndex = number;

interface MemberStore {
   username: string
   intros: IntroIndex[]
}

interface Intro {
    name: string
    filename: string
    length: number
}

function createMemberStore(): MemberStore {
    const { subscribe, set, update } = writable(null)

    return {
        subscribe: subscribe,
        set: set,
        addIntro: (intro: IntroIndex) => { update((n) => n.intros.push(intro)); return intro },
        _fakeLogin: () => set(
            {
                username: "TestUser",
                intros: [0,1]
            }
        ),
    }
}

export const member: MemberStore = createMemberStore()
export const intros: IntroStore = readable([], (set) => {
        // TODO: actually grab intros from the API
        set([
            { name: "TestSound", filename: "testsound.mp3", length: 30 },
            { name: "Huh?", filename: "tim allen.mp3", length: 2 },
            { name: "This sound hasn't been selected yet", filename: "totally_real.mp3", length: 9 },
        ])

        return () => {}
    })

